using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace StatisticalAnalyzer
{
	/// <summary>
	/// Summary description for BasicInfo.
	/// </summary>
	public class BasicInfo : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox GENBasicInfo_TB;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox ADCBasicInfo_TB;
		private System.Windows.Forms.Label label2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private Hashtable ADCBasicInfoBuffer;
		private System.Windows.Forms.Button Exit_Btn;
		private Hashtable GENBasicInfoBuffer;


		public BasicInfo(Hashtable p_ADCBasicInfoBuffer, Hashtable p_GENBasicInfoBuffer)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		    ADCBasicInfoBuffer = p_ADCBasicInfoBuffer;
		    GENBasicInfoBuffer = p_GENBasicInfoBuffer;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.GENBasicInfo_TB = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.ADCBasicInfo_TB = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.Exit_Btn = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// GENBasicInfo_TB
			// 
			this.GENBasicInfo_TB.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.GENBasicInfo_TB.Location = new System.Drawing.Point(8, 48);
			this.GENBasicInfo_TB.Multiline = true;
			this.GENBasicInfo_TB.Name = "GENBasicInfo_TB";
			this.GENBasicInfo_TB.ReadOnly = true;
			this.GENBasicInfo_TB.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.GENBasicInfo_TB.Size = new System.Drawing.Size(320, 288);
			this.GENBasicInfo_TB.TabIndex = 0;
			this.GENBasicInfo_TB.Text = "";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(296, 24);
			this.label1.TabIndex = 1;
			this.label1.Text = "Basic Information from the GEN :";
			// 
			// ADCBasicInfo_TB
			// 
			this.ADCBasicInfo_TB.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ADCBasicInfo_TB.Location = new System.Drawing.Point(336, 48);
			this.ADCBasicInfo_TB.Multiline = true;
			this.ADCBasicInfo_TB.Name = "ADCBasicInfo_TB";
			this.ADCBasicInfo_TB.ReadOnly = true;
			this.ADCBasicInfo_TB.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.ADCBasicInfo_TB.Size = new System.Drawing.Size(312, 288);
			this.ADCBasicInfo_TB.TabIndex = 2;
			this.ADCBasicInfo_TB.Text = "";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(344, 0);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(304, 40);
			this.label2.TabIndex = 3;
			this.label2.Text = "Basic Information from the AutoDataCollection :";
			// 
			// Exit_Btn
			// 
			this.Exit_Btn.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Exit_Btn.Location = new System.Drawing.Point(184, 352);
			this.Exit_Btn.Name = "Exit_Btn";
			this.Exit_Btn.Size = new System.Drawing.Size(320, 48);
			this.Exit_Btn.TabIndex = 4;
			this.Exit_Btn.Text = "Exit";
			this.Exit_Btn.Click += new System.EventHandler(this.Exit_Btn_Click);
			// 
			// BasicInfo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.RosyBrown;
			this.ClientSize = new System.Drawing.Size(656, 405);
			this.Controls.Add(this.Exit_Btn);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.ADCBasicInfo_TB);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.GENBasicInfo_TB);
			this.Name = "BasicInfo";
			this.Text = "BasicInfo";
			this.Load += new System.EventHandler(this.BasicInfo_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void ShowGENBasicInfo()
		{
			try
			{
				
				IDictionaryEnumerator ide_GEN = GENBasicInfoBuffer.GetEnumerator();
				while(ide_GEN.MoveNext())
				{
                    string strKey = ide_GEN.Key.ToString();
					if(strKey.Equals("NumOfNodes"))
					{
						GENBasicInfo_TB.Text += "Number of Nodes Participated: "+ide_GEN.Value.ToString()+"\r\n";        
					}
					else if(strKey.Equals("SA_Width"))
					{
						GENBasicInfo_TB.Text += "Width of Simulation Area: "+ide_GEN.Value.ToString()+"\r\n";                                
					}
					else if(strKey.Equals("SA_Height"))
					{
						GENBasicInfo_TB.Text += "Height of Simulation Area: "+ide_GEN.Value.ToString()+"\r\n";                                
					}
					else if(strKey.Equals("PowerRange"))
					{
						GENBasicInfo_TB.Text += "Power Range: "+ide_GEN.Value.ToString()+"\r\n";                                
					}
					else if(strKey.Equals("Speed"))
					{
						GENBasicInfo_TB.Text += "Speed: "+ide_GEN.Value.ToString()+"\r\n";                                
					}
					else if(strKey.Equals("PauseTime"))
					{
						GENBasicInfo_TB.Text += "Pause Time: "+ide_GEN.Value.ToString()+"\r\n";                                
					}
				}
  			}
			catch(Exception e)
			{
               MessageBox.Show("Exception in ShowGENBasicInfo(): "+e.Message);
			}
		}

		private void ShowADCBasicInfo()
		{
			try
			{
                IDictionaryEnumerator ide_ADC = ADCBasicInfoBuffer.GetEnumerator();
				while(ide_ADC.MoveNext())
				{
                    string strKey = ide_ADC.Key.ToString();
					if(strKey.Equals("Source"))
					{
						ADCBasicInfo_TB.Text += "Source : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("Target"))
					{
						ADCBasicInfo_TB.Text += "Target : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("ACM"))
					{
						ADCBasicInfo_TB.Text += "All Nodes are Connected with Multi-Hops (ACM) : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("Cache"))
					{
						ADCBasicInfo_TB.Text += "Use of Cache Feature : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("SWS"))
					{
						ADCBasicInfo_TB.Text += "Sliding Window Size (SWS) : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("NumOfDataPacket"))
					{
						ADCBasicInfo_TB.Text += "Number of Data Packets Transmitted : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("ReceiptPacket"))
					{
						ADCBasicInfo_TB.Text += "Use of Receipt Packet : "+ide_ADC.Value.ToString()+"\r\n";
					}
					else if(strKey.Equals("TrafficControlParam"))
					{
						ADCBasicInfo_TB.Text += "Traffic Control Parameter : "+ide_ADC.Value.ToString()+"\r\n";
					}
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in ShowADCBasicInfo(): "+e.Message);
			}
		}
		
		private void BasicInfo_Load(object sender, System.EventArgs e)
		{
			ShowGENBasicInfo();
			ShowADCBasicInfo();
		}

		private void Exit_Btn_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

	}//end of main
}
